/*-----------------------------------------------------------------*/
/* Type definitions */
/*-----------------------------------------------------------------*/

typedef struct interval_t Interval;
typedef struct info_t Info;

typedef struct interval_t {
   char target[64];
   char final[64];
   char **stopAdr;
   int nofStopAdrs;
   double *times;
   double *btimes;
   int ilength;
   int idx;
   double startTime;
   double accumulativeTime;
   int nofAccumulative;
   double temp;
   int trials;
   int firstIteration;
   Info **info;
   Interval *nextinhash;
} interval_t ; 


typedef struct info_t {
   char fullAddress[64];
   int typecode;
   int cidx;
   int aidx;
   int bidx;
   int *selection;
   int selectionLength;
   double *relcost;
} info_t;

/*-----------------------------------------------------------------*/

#define STREQUALS(A,B) (strcmp((A),(B))==0)
#define MAX_TIME 1000.00
#define OB_COLLECTIVE 65504


enum ob_typecodes{ OB_SCAMEMFORCEFUNCTION=1, OB_INIT=2 ,OB_FINALIZE=4, \
		   OB_SEND=8, OB_RECV=16, OB_SENDRECV=32, \
		   OB_ALLGATHER=64, OB_ALLTOALL=128, OB_GATHER=256, \
		   OB_SCATTER=512, OB_BCAST=1024, OB_BARRIER=2048, \
		   OB_ALLREDUCE=4096, OB_REDUCE=8192, \
		   OB_REDUCE_SCATTER=16384, OB_SCAN=32768, OB_WAIT=65536, \
		   OB_DONTCARE = 0 };


typedef void (*ob_inter_t) (char *);

ob_inter_t ob_interval;

void ob_inter_init(void);
void ob_inter_final(void);

void ob_simAnnealOnce( Interval *, double, int);
void ob_sao_init(void);


/***** THIS CODE SECTION WERE INCLUDED IN THE PMPI FUNCTIONS, NOT IN THIS HEADER FILE ******/

#define RegisterMPICall(ob_typecode,ob_dtt,ob_len)                                \
{                                                                                 \
   int ob_size=0;                                                                 \
   char ob_str[64];                                                               \
   if( (ob_dtt) != -1 )                                                           \
      MPI_Type_size((ob_dtt),&ob_size);                                           \
   ob_size *= (ob_len);                                                           \
   sprintf(ob_str,"%p %d %d",__builtin_return_address(0), (ob_typecode),ob_size );\
   ob_interval(ob_str);                                                           \
}
